/*
 *   Copyright (C) 2007 Thomas Georgiou <TAGeorgiou@gmail.com> and Jeff Cooper <weirdsox11@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "dictengine.h"

#include <KDebug>
#include <QtNetwork>
#include "plasma/datasource.h"

DictEngine::DictEngine(QObject* parent, const QStringList& args)
    : Plasma::DataEngine(parent)
{
    Q_UNUSED(args)
}
DictEngine::~DictEngine()
{
}

void DictEngine::getDefinition()
{
      tcpSocket->waitForReadyRead();
      tcpSocket->readAll();
      QByteArray ret;
      
      tcpSocket->write(QByteArray("DEFINE gcide "));
      tcpSocket->write(currentWord.toAscii());
      tcpSocket->write(QByteArray("\n"));
      tcpSocket->flush();
      
      while (!ret.contains("250") && !ret.contains("552"))
      {
        tcpSocket->waitForReadyRead();
        ret += tcpSocket->readAll();
      }
      
      QByteArray def = QByteArray();
      
      QList<QByteArray> retLines= ret.split('\n');
      
      while (!retLines.empty())
      {
          QByteArray curr = retLines.takeFirst();
          if (!(curr.startsWith("150") || curr.startsWith("151") || curr.startsWith("250") || curr.startsWith("552")))
          {
              def += curr;
              def += "\n";
          }
          if (curr.startsWith("552"))
              def=(tr("No match found for ") + currentWord + tr(".")).toUtf8();
      }
      
      setData(currentWord,QString("gcide"),QString(def));
}

bool DictEngine::sourceRequested(const QString &word)
{
      currentWord = word;
      tcpSocket = new QTcpSocket(this);
      tcpSocket->abort();
      connect(tcpSocket, SIGNAL(connected()), this ,SLOT(getDefinition()));
      tcpSocket->connectToHost("dict.org", 2628);
      return true;
}

#include "dictengine.moc"
